sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) Geoworks 1995 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_ORANGE	&Hffaa5500, LIGHT_ORANGE	&Hffff5555
CONST YELLOW		&Hffffff55
CONST RED		&Hffaa0000

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST PEN_PRESS 1, PEN_HOLD 2, PEN_DRAG 3, PEN_TO 4, PEN_RELEASE 5
CONST PEN_LOST 6, PEN_FLY_OVER 7

CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91
REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=86
left=98
sizeHControl=0
sizeVControl=0
caption="Demo: Laufschrift"
tile=1
tileSpacing=20
End CompInit
Dim label1 as label
label1 = MakeComponent("label",form1)
CompInit label1
proto="label1"
caption="Kleine Laufschrift"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label1.name="label1"
Dim button1 as button
button1 = MakeComponent("button",form1)
CompInit button1
proto="button1"
caption="Start"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
button1.name="button1"
Dim label2 as label
label2 = MakeComponent("label",form1)
CompInit label2
proto="label3"
caption="Vorwrts <-"
sizeVControl=3
sizeHControl=3
visible=1
End CompInit
label2.name="label2"
Dim label3 as label
label3 = MakeComponent("label",form1)
CompInit label3
proto="label2"
caption="Rckwrts -> "
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label3.name="label3"
form1.name="form1"
form1.height=191
form1.width=314
Dim timer1 as timer
timer1 = MakeComponent("timer","app")
CompInit timer1
proto="timer1"
interval=10
End CompInit
timer1.name="timer1"
Dim timer2 as timer
timer2 = MakeComponent("timer","app")
CompInit timer2
proto="timer2"
interval=20
End CompInit
timer2.name="timer2"
Dim timer3 as timer
timer3 = MakeComponent("timer","app")
CompInit timer3
proto="timer3"
interval=5
End CompInit
timer3.name="timer3"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

rem Definition der Variablentypen und bei den String-Variablen deren Inhalt

dim text1a as string
dim text2a as string
dim laengea as integer
dim text1b as string
dim text2b as string
dim laengeb as integer
dim text1c as string
dim text2c as string
dim laengec as integer

text2a = " Kleine Laufschrift - Demonstration"
text2b = " Von rechts nach links laufender Text. <-"
text2c = " Von links nach rechts laufender Text. ->"

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub timer1_ring(self as timer)

rem Timer fuer "Kleine Laufschrift"
rem Zuerst wird die Laenge der Zeichenkette ermittelt, dann wird wird das
rem erste Zeichen dieser in die Variable "text1a" uebergeben. In der naechsten
rem Zeile wird der Rest der Zeichenkette (Start der MID-Funktion an der 2.
rem Stelle der Zeichenkette mit einer um eins (text1a) verkuerzten Laenge)
rem ermittelt und am Ende das erste Zeichen aus "text1a" angehaengt, um den
rem Laufeffekt zu erzielen. Am Ende erfolgt die Ausgabe der Zeichenkette an
rem das Label.

laengea = len(text2a)
text1a = mid(text2a,1,1)
text2a = mid(text2a,2,laengea-1)+text1a
label1.caption = text2a

end sub

sub button1_pressed(self as button)

rem Bei einem Klick auf die Taste (Start/Stop) wird diese Routine auf-
rem gerufen. Zuerst wird ueberprueft ob die Start- oder Stop-Funktion
rem ausgeloest werden soll. Entsprechende dieses Ergebnisses werden die
rem drei Timer ein- bzw. ausgeschaltet und die Beschriftung der Taste
rem geaendert.

if button1.caption = "Start" then
	button1.caption = "Stop"
	timer1.enabled = 1
	timer2.enabled = 1
	timer3.enabled = 1
else
	button1.caption = "Start"
	timer1.enabled = 0
	timer2.enabled = 0
	timer3.enabled = 0
end if

end sub

sub timer2_ring(self as timer)

rem Laufschrift vorwaerts (von rechts nach links)
rem Funktion entspricht der von "timer1_ring", nur das diesmal statt der
rem MID()-Funktion die RIGHT()-Funktion verwendet wurde.

laengeb = len(text2b)
text2b = right(text2b,laengeb-1)+left(text2b,1)
label2.caption = text2b

end sub

sub timer3_ring(self as timer)

rem Laufschrift rueckwaerts (von links nach rechts)
rem Zuerst wird wieder die Laenge des Zeichenstrings (text2c) ermittelt,
rem danach erfolgt die Umstellung dieses, um das "rueckwaerts laufen" zu
rem erzielen:  das erste Zeichen ist das rechteste (letzte), danach wird
rem der Rest des Zeichenstrings angehangen. Alle Zeichen von Links mit einer
rem um eins verkuerzten Laenge, da das letzte Zeichen schon am Anfang steht.
rem Am Ende erfolgt die Ausgabe des Zeichstrings auf das Label.

laengec = len(text2c)
text2c = right(text2c,1)+left(text2c,laengec-1)
label3.caption = text2c

end sub

