sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) Geoworks 1995 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_ORANGE	&Hffaa5500, LIGHT_ORANGE	&Hffff5555
CONST YELLOW		&Hffffff55
CONST RED		&Hffaa0000

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST PEN_PRESS 1, PEN_HOLD 2, PEN_DRAG 3, PEN_TO 4, PEN_RELEASE 5
CONST PEN_LOST 6, PEN_FLY_OVER 7

CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91
REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=88
left=93
tile=1
caption="Beispiel fr Popup"
End CompInit
Dim popup1 as popup
popup1 = MakeComponent("popup",form1)
CompInit popup1
proto="popup1"
caption="Datei"
left=0
top=0
visible=1
End CompInit
Dim button1 as button
button1 = MakeComponent("button",popup1)
CompInit button1
proto="button1"
caption="ber..."
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
button1.name="button1"
popup1.name="popup1"
Dim popup2 as popup
popup2 = MakeComponent("popup",form1)
CompInit popup2
proto="popup2"
caption="Sonstiges"
left=0
top=0
visible=1
End CompInit
Dim spacer1 as spacer
spacer1 = MakeComponent("spacer",popup2)
CompInit spacer1
proto="spacer1"
look=1
width=91
sizeVControl=3
visible=1
End CompInit
spacer1.name="spacer1"
Dim choice3 as choice
choice3 = MakeComponent("choice",popup2)
CompInit choice3
proto="choice3"
caption="Text: Blau"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
choice3.name="choice3"
Dim choice4 as choice
choice4 = MakeComponent("choice",popup2)
CompInit choice4
proto="choice4"
caption="Text: Grn"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
choice4.name="choice4"
Dim choice5 as choice
choice5 = MakeComponent("choice",popup2)
CompInit choice5
proto="choice5"
caption="Text: Rot"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
choice5.name="choice5"
Dim spacer2 as spacer
spacer2 = MakeComponent("spacer",popup2)
CompInit spacer2
proto="spacer2"
sizeVControl=3
width=91
look=2
visible=1
End CompInit
spacer2.name="spacer2"
Dim toggle3 as toggle
toggle3 = MakeComponent("toggle",popup2)
CompInit toggle3
proto="toggle3"
caption="Sperren"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
toggle3.name="toggle3"
popup2.name="popup2"
Dim text2 as text
text2 = MakeComponent("text",form1)
CompInit text2
proto="text2"
width=175
height=85
End CompInit
text2.name="text2"
text2.AppendString("Beispiel fr Popup-Mens:\r")
text2.AppendString("- Datei/ber... ruft eine\r")
text2.AppendString("  Dialogbox auf\r")
text2.AppendString("- Sonstiges erlaubt die\r")
text2.AppendString("  nderung der Textfarbe\r")
text2.AppendString("  und das sperren/freigeben\r")
text2.AppendString("  des Textfeldes.")
text2.visible=1
form1.width=213
form1.height=139
form1.name="form1"
Dim dialog1 as dialog
dialog1 = MakeComponent("dialog","app")
CompInit dialog1
proto="dialog1"
left=317
top=111
caption="ber..."
End CompInit
Dim group1 as group
group1 = MakeComponent("group",dialog1)
CompInit group1
proto="group1"
caption="group1"
left=16
top=6
height=108
width=189
look=2
tile=1
tileVAlign=1
visible=1
End CompInit
Dim text1 as text
text1 = MakeComponent("text",group1)
CompInit text1
proto="text1"
width=173
End CompInit
text1.name="text1"
text1.AppendString("Dieses NewBASIC-Programm\r")
text1.AppendString("ist Teil einer Sammlung zum\r")
text1.AppendString("besseren  Verstndnis   von\r")
text1.AppendString("NewBASIC.")
text1.visible=1
Dim button5 as button
button5 = MakeComponent("button",group1)
CompInit button5
proto="button5"
caption="OK"
default=1
closeDialog=1
visible=1
End CompInit
button5.name="button5"
group1.name="group1"
dialog1.height=150
dialog1.width=239
dialog1.name="dialog1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

text2.color = LIGHT_GREEN

dim tb as integer
dim tg as integer
dim tr as integer

tg = 1


end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub button1_pressed(self as button)
	dialog1.visible = 1
end sub

sub choice3_changed(self as choice)
	text2.color = LIGHT_BLUE
end sub

sub choice4_changed(self as choice)
	text2.color = DARK_GREEN
end sub

sub choice5_changed(self as choice)
	text2.color = RED
end sub

sub toggle3_changed(self as toggle)

if toggle3.caption = "Sperren" then
	toggle3.caption = "Freigeben"
	text2.readOnly = 1
else
	toggle3.caption = "Sperren"
	text2.readOnly = 0
end if

end sub

function textfarbe()
rem
end function

