sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) Geoworks 1995 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_ORANGE	&Hffaa5500, LIGHT_ORANGE	&Hffff5555
CONST YELLOW		&Hffffff55
CONST RED		&Hffaa0000

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST PEN_PRESS 1, PEN_HOLD 2, PEN_DRAG 3, PEN_TO 4, PEN_RELEASE 5
CONST PEN_LOST 6, PEN_FLY_OVER 7

CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91
REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=80
left=87
sizeHControl=0
sizeVControl=0
tile=1
caption="NBM1: Anzeige"
End CompInit
Dim popup1 as popup
popup1 = MakeComponent("popup",form1)
CompInit popup1
proto="popup1"
caption="Datei"
left=0
top=0
visible=1
End CompInit
Dim button2 as button
button2 = MakeComponent("button",popup1)
CompInit button2
proto="button2"
caption="ber..."
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
button2.name="button2"
popup1.name="popup1"
Dim popup2 as popup
popup2 = MakeComponent("popup",form1)
CompInit popup2
proto="popup2"
caption="Fenster"
left=0
top=0
visible=1
End CompInit
Dim toggle1 as toggle
toggle1 = MakeComponent("toggle",popup2)
CompInit toggle1
proto="toggle1"
caption="Zeiger"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
toggle1.name="toggle1"
Dim toggle2 as toggle
toggle2 = MakeComponent("toggle",popup2)
CompInit toggle2
proto="toggle2"
caption="Scope"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
toggle2.name="toggle2"
Dim toggle3 as toggle
toggle3 = MakeComponent("toggle",popup2)
CompInit toggle3
proto="toggle3"
caption="Balken"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
toggle3.name="toggle3"
Dim toggle4 as toggle
toggle4 = MakeComponent("toggle",popup2)
CompInit toggle4
proto="toggle4"
caption="Linie"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
toggle4.name="toggle4"
Dim toggle5 as toggle
toggle5 = MakeComponent("toggle",popup2)
CompInit toggle5
proto="toggle5"
caption="Punkt"
sizeHControl=3
status=1
sizeVControl=3
visible=1
End CompInit
toggle5.name="toggle5"
popup2.name="popup2"
Dim group1 as group
group1 = MakeComponent("group",form1)
CompInit group1
proto="group1"
caption=""
sizeHControl=0
sizeVControl=0
width=313
height=216
visible=1
End CompInit
Dim scrollbar1 as scrollbar
scrollbar1 = MakeComponent("scrollbar",group1)
CompInit scrollbar1
proto="scrollbar1"
sizeHControl=0
sizeVControl=0
height=180
width=12
maximum=100
value=1
minimum=1
notifyDrag=1
left=285
top=8
visible=1
End CompInit
scrollbar1.name="scrollbar1"
Dim label1 as label
label1 = MakeComponent("label",group1)
CompInit label1
proto="label1"
caption="?"
sizeHControl=3
sizeVControl=3
left=289
top=197
visible=1
End CompInit
label1.name="label1"
Dim text2 as text
text2 = MakeComponent("text",group1)
CompInit text2
proto="text2"
left=8
top=5
readOnly=1
width=260
height=204
look=2
End CompInit
text2.name="text2"
text2.AppendString("Kleiner Test, wie man eine Grsse in\r")
text2.AppendString("verschiedenen Formen darstellen kann.\r")
text2.AppendString("\r")
text2.AppendString("1) Zeiger - die klassische Anziege\r")
text2.AppendString("2) als Scope - Werte werden einfach an-\r")
text2.AppendString("einandergereiht dargestellt.\r")
text2.AppendString("3) Balken - die Grsse des Balkens zeigt\r")
text2.AppendString("immer den aktuellen Wert an. Dieser wird\r")
text2.AppendString("zustzlich in der Titelzeile dargestellt.\r")
text2.AppendString("4) Punktanzeige\r")
text2.AppendString("5) wie Punktanzeige, nur das die Punkte\r")
text2.AppendString("untereinander verbunden sind.\r")
text2.AppendString("\r")
text2.AppendString("Die Erneuerung erfolgt ein mal pro\r")
text2.AppendString("Sekunde (akt. Signal) ber einen Timer.")
text2.visible=1
group1.name="group1"
Dim popup3 as popup
popup3 = MakeComponent("popup",form1)
CompInit popup3
proto="popup3"
caption="Setup"
left=0
top=0
visible=1
End CompInit
Dim toggle6 as toggle
toggle6 = MakeComponent("toggle",popup3)
CompInit toggle6
proto="toggle6"
caption="Sound (Takt)"
sizeHControl=3
sizeVControl=0
height=14
status=1
visible=1
End CompInit
toggle6.name="toggle6"
popup3.name="popup3"
form1.name="form1"
form1.height=292
form1.width=320
Dim dialog1 as dialog
dialog1 = MakeComponent("dialog","app")
CompInit dialog1
proto="dialog1"
left=57
top=432
caption="Zeigerinstrument"
tile=1
sizeHControl=0
sizeVControl=0
End CompInit
Dim gadget1 as gadget
gadget1 = MakeComponent("gadget",dialog1)
CompInit gadget1
proto="gadget1"
width=200
height=100
visible=1
End CompInit
Dim gadget2 as gadget
gadget2 = MakeComponent("gadget",gadget1)
CompInit gadget2
proto="gadget2"
sizeHControl=3
sizeVControl=3
left=0
top=2
visible=1
End CompInit
gadget2.name="gadget2"
gadget1.name="gadget1"
dialog1.height=160
dialog1.width=240
dialog1.name="dialog1"
Dim dialog2 as dialog
dialog2 = MakeComponent("dialog","app")
CompInit dialog2
proto="dialog2"
left=305
top=432
caption="Scope"
tile=1
End CompInit
Dim gadget3 as gadget
gadget3 = MakeComponent("gadget",dialog2)
CompInit gadget3
proto="gadget3"
width=200
height=100
visible=1
End CompInit
gadget3.name="gadget3"
dialog2.height=160
dialog2.width=240
dialog2.name="dialog2"
Dim dialog3 as dialog
dialog3 = MakeComponent("dialog","app")
CompInit dialog3
proto="dialog3"
left=433
top=89
caption="ber..."
tile=1
End CompInit
Dim text1 as text
text1 = MakeComponent("text",dialog3)
CompInit text1
proto="text1"
width=145
height=36
readOnly=1
End CompInit
text1.name="text1"
text1.AppendString("Dieses Demoprogramm\r")
text1.AppendString("wurde von Dirk Haase\r")
text1.AppendString("geschrieben. Usw, ...")
text1.visible=1
Dim spacer1 as spacer
spacer1 = MakeComponent("spacer",dialog3)
CompInit spacer1
proto="spacer1"
width=13
visible=1
End CompInit
spacer1.name="spacer1"
dialog3.height=154
dialog3.width=239
dialog3.name="dialog3"
Dim sound1 as sound
sound1 = MakeComponent("sound","app")
CompInit sound1
proto="sound1"
End CompInit
sound1.name="sound1"
Dim timer1 as timer
timer1 = MakeComponent("timer","app")
CompInit timer1
proto="timer1"
End CompInit
timer1.name="timer1"
Dim dialog4 as dialog
dialog4 = MakeComponent("dialog","app")
CompInit dialog4
proto="dialog4"
left=551
top=430
tile=1
caption="Balken"
End CompInit
Dim gadget4 as gadget
gadget4 = MakeComponent("gadget",dialog4)
CompInit gadget4
proto="gadget4"
width=200
height=100
visible=1
End CompInit
gadget4.name="gadget4"
dialog4.height=160
dialog4.width=240
dialog4.name="dialog4"
Dim dialog5 as dialog
dialog5 = MakeComponent("dialog","app")
CompInit dialog5
proto="dialog5"
left=553
top=265
caption="Punktanzeige"
tile=1
End CompInit
Dim gadget5 as gadget
gadget5 = MakeComponent("gadget",dialog5)
CompInit gadget5
proto="gadget5"
width=200
height=100
visible=1
End CompInit
gadget5.name="gadget5"
dialog5.height=160
dialog5.width=240
dialog5.name="dialog5"
Dim dialog6 as dialog
dialog6 = MakeComponent("dialog","app")
CompInit dialog6
proto="dialog6"
left=550
top=96
caption="Linienauswertung"
tile=1
End CompInit
Dim gadget6 as gadget
gadget6 = MakeComponent("gadget",dialog6)
CompInit gadget6
proto="gadget6"
width=200
height=100
visible=1
End CompInit
gadget6.name="gadget6"
dialog6.height=160
dialog6.width=240
dialog6.name="dialog6"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

	CONST GREEN 	&hff55ff55		rem Farbdefinition fuer Zeiger
	CONST GREY		&hffaaaaaa
	CONST BLUE		&hff00aaaa

	CONST PURPLE	&hff00ffaa
	CONST ORANGE	&hffaa5500

	dialog1.visible = 1	rem Zeiger		rem Dialogfenster beim Start anzeigen
	dialog2.visible = 1	rem Scope
	dialog4.visible = 1	rem Balken
	dialog5.visible = 1	rem Punkt
	dialog6.visible = 1	rem Linie

rem 	timer1.enabled = 1			rem Timer beim Programmstart einschalten
	
	DIM xStart AS integer		rem Typ der Variablen festlegen
	DIM yStart AS integer		rem Zeiger
	DIM xEnd AS integer
	DIM yEnd AS integer
	DIM color AS long

	DIM xEndalt AS integer		rem Typ der Variablen festlegen
	DIM yEndalt AS integer		rem fuer alten Zeiger

	xEndalt = 0
	yEndalt = 1

	dim zaehler2 as integer		rem Zaehler fuer x-Richtung
	zaehler2 = 0

	rem Linienanzeige
	dim StartX as integer
	dim StartY as integer
	dim ZielX as integer
	dim ZielY as integer

	StartX = 0
	StartY = 100
	ZielX = 0
	ZielY = 0
	dim bcolor as long
	bcolor = GREEN
	
end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub toggle1_changed(self as toggle)

rem Zeiger-Dialogfenster ein / aus

	if toggle1.status = 1
		dialog1.visible = 1
	else
		dialog1.visible = 0
	end if

end sub

sub toggle2_changed(self as toggle)

rem Scope-Dialogfenster ein / aus

	if toggle2.status = 1
		dialog2.visible = 1
	else
		dialog2.visible = 0
	end if

end sub

sub button2_pressed(self as button)

	dialog3.visible = 1

rem Anzeige des "Ueber..."-Informationsfensters

end sub

sub timer1_ring(self as timer)

rem 	sub timer1_ring(self as timer)
rem 	bei Betrieb ueber Timer, laueft also automatisch. Der Timer ist in der
rem		Grundeinstellung deaktiviert, die Werte werden ausgewertet, sobald
rem		der Balken innerhalb der Scrollbar bewegt wird. Um auf den Timer um-
rem		zustellen, muss die Routine:
rem		sub scrollbar1_changed(self as scrollbar, scrollType as integer)
rem		geloescht und das rem vom der Timeraktivierung in module_init entfernt
rem		werden. Dann wird aller 1 Sekunde der Wert der Scrollbar abgefragt und
rem		ausgewertet.

	label1.caption = str(scrollbar1.value) + "   "

	if toggle6.status = 1 then
		sound1.StandardSound(2)
	end if
	
	rem Zeigerinstrument
	rem ----------------
		
	xStart = 100		rem Ausgangspunkt fuer Zeiger setzen
	yStart = 100

	xEnd = int(sin((((((scrollbar1.value * 1.8)-90)*100)/57.29578)/100))*100)+100
	yEnd = int(sin(((((90-((scrollbar1.value * 1.8) - 90))*100)/57.29578)/100))*100)

rem		die 57.29... ergeben sich durch 180 / PI
rem 	Multiplikation mit 1.8 um die 100 Eingangswerte auf 180 Grad zu verteilen

	gadget1.DrawLine( xStart, yStart, xEndalt, -yEndalt, GREY )
	gadget1.DrawLine( xStart, yStart, xEnd, -yEnd, RED )
	
	xEndalt = xEnd	rem vorhergehenden Zeiger uebermalen
	yEndalt = yEnd
	
	rem Scope
	rem -----
	zaehler2 = zaehler2 + 1
	
 	gadget3.DrawLine(zaehler2, 100 ,zaehler2, 100 - scrollbar1.value, GREEN)

	rem Punktauswertung
	rem ---------------
	gadget5.DrawLine(zaehler2, 100 - scrollbar1.value ,zaehler2, 100 - scrollbar1.value, YELLOW)

	rem Linienauswertung
	rem ----------------

	ZielX = zaehler2
	ZielY = 100 - scrollbar1.value

	gadget6.DrawLine(StartX, StartY, ZielX, ZielY, BLUE)

	StartX = zaehler2
	StartY = 100 - scrollbar1.value

	if zaehler2 = 200 then
		zaehler2 = 0
		
		gadget3.DrawRect(0,0, 200, 100, GREY)	rem Gadgets "leeren"
		gadget5.DrawRect(0,0, 200, 100, GREY)
		gadget6.DrawRect(0,0, 200, 100, GREY)
		
	end if

	rem Balken
	rem ------
	
	if scrollbar1.value < 25 then				rem Balken aendert je nach Wert
		bcolor = GREEN							rem seine Farbe:
	else											rem gruen/gelb/orange/rot
		if scrollbar1.value < 50 then
			bcolor = YELLOW
		else
			if scrollbar1.value < 75 then
				bcolor = ORANGE
			else
				bcolor = RED
			end if
		end if
	end if
	
	dialog4.caption = "Balken - akt. Wert: " + str(scrollbar1.value)
	
	gadget4.DrawRect(0,0, 200, 100, GREY)
	gadget4.DrawRect(0,0, scrollbar1.value * 2, 100, bcolor)

rem Das ganze funktioniert zwar, aber sobald ein anderes Fenster ueber das
rem Gadget kommt oder einer der Dialogboxen mit einem geschlossen wurde,
rem wird nach Wiederaufruf / - sichtbarwerden, der alte Inhalt nicht erneut
rem gezeichnet.

end sub

sub toggle3_changed(self as toggle)

rem Balken-Dialogfenster ein / aus

	if toggle3.status = 1
		dialog4.visible = 1
	else
		dialog4.visible = 0
	end if

end sub

sub toggle4_changed(self as toggle)

rem Linie-Dialogfenster ein/aus

	if toggle4.status = 1
		dialog6.visible = 1
	else
		dialog6.visible = 0
	end if

end sub

sub toggle5_changed(self as toggle)

rem Punktanzeige-Dialogfenster ein / aus

		if toggle5.status = 1
		dialog5.visible = 1
	else
		dialog5.visible = 0
	end if

end sub

sub scrollbar1_changed(self as scrollbar, scrollType as integer)

rem 	fuer den automatischen Betrieb ueber den Timer, siehe:
rem 	sub timer1_ring(self as timer)

	label1.caption = str(scrollbar1.value) + "   "

rem		Leerzeichen am Ende erforderlich, um auch alle vorher dargestellten
rem		Zeichen des Labels zu loeschen

	if toggle6.status = 1 then
		sound1.StandardSound(2)
	end if

rem		wenn Takt aktiviert, wird ein akustisches Signal ausgegeben

	rem Zeigerinstrument
	rem ----------------
		
	xStart = 100		rem Ausgangspunkt fuer Zeiger setzen
	yStart = 100

	xEnd = int(sin((((((scrollbar1.value * 1.8)-90)*100)/57.29578)/100))*100)+100
	yEnd = int(sin(((((90-((scrollbar1.value * 1.8) - 90))*100)/57.29578)/100))*100)

rem		die 57.29... ergeben sich durch 180 / PI
rem 	Multiplikation mit 1.8 um die 100 Eingangswerte auf 180 Grad zu verteilen

	gadget1.DrawLine( xStart, yStart, xEndalt, -yEndalt, GREY )
	gadget1.DrawLine( xStart, yStart, xEnd, -yEnd, RED )

rem		uebermalen des vorherigen Zeigers mit grau
rem		zeichnen des neuen Zeigers

	xEndalt = xEnd	rem Wertuebergabe um beim naechsten Aufruf den
	yEndalt = yEnd	rem vorhergehenden Zeiger uebermalen
	
	rem Scope
	rem -----
	
	zaehler2 = zaehler2 + 1
	
 	gadget3.DrawLine(zaehler2, 100 ,zaehler2, 100 - scrollbar1.value, GREEN)

	rem Punktauswertung
	rem ---------------
	
	gadget5.DrawLine(zaehler2, 100 - scrollbar1.value ,zaehler2, 100 - scrollbar1.value, YELLOW)

	rem Linienauswertung
	rem ----------------

	ZielX = zaehler2
	ZielY = 100 - scrollbar1.value

	gadget6.DrawLine(StartX, StartY, ZielX, ZielY, BLUE)

	StartX = zaehler2
	StartY = 100 - scrollbar1.value

	if zaehler2 = 200 then
		zaehler2 = 0
		
		gadget3.DrawRect(0,0, 200, 100, GREY)	rem Gadgets "leeren"
		gadget5.DrawRect(0,0, 200, 100, GREY)
		gadget6.DrawRect(0,0, 200, 100, GREY)
		
		StartX = 0		rem zuruecksetzen fuer Neuzeichnen
		
	end if

	rem Balken
	rem ------
	
	if scrollbar1.value < 25 then				rem Balken aendert je nach Wert
		bcolor = GREEN							rem seine Farbe:
	else											rem gruen/gelb/orange/rot
		if scrollbar1.value < 50 then
			bcolor = YELLOW
		else
			if scrollbar1.value < 75 then
				bcolor = ORANGE
			else
				bcolor = RED
			end if
		end if
	end if
	
	dialog4.caption = "Balken - akt. Wert: " + str(scrollbar1.value)
	
	gadget4.DrawRect(0,0, 200, 100, GREY)
	gadget4.DrawRect(0,0, scrollbar1.value * 2, 100, bcolor)

rem Das ganze funktioniert zwar, aber sobald ein anderes Fenster ueber das
rem Gadget kommt oder einer der Dialogboxen mit einem geschlossen wurde,
rem wird nach Wiederaufruf / - sichtbarwerden, der alte Inhalt nicht erneut
rem gezeichnet.

end sub

